Attribute VB_Name = "Start"
' By HaCeSOFT
' Pavel Prochazka
' hacesoft@mujmail.cz
' www.prochazka.zde.cz
'
'
' Tento program a knihovna AdresaPortu.dll + Knihovna.dll muzete pouzivat neomezene
'  pro NEKOMERCNI ucely!!!
'
'
' Upraveno 7.2.2006: v 19:45
'
'


Private Const WIN_2000_XP_NET = 5
Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Enum HKEYTypDll
    OTHER = 1
    API = 2
    ACTIVE_X = 3
    OCX = 4
End Enum

Private Enum HKEYError
    ERROR_SUCCESS = 0
    ERROR_MORE_DATA = 234&
    ERROR_NO_MORE_ITEMS = 259&
End Enum

Private Enum HKEYDataType
    REG_NONE = 0&
    REG_SZ = 1&
    REG_BINARY = 3
    REG_DWORD = 4
End Enum

Public Declare Function GetVersionExA Lib "kernel32" (lpVersionInformation As OSVERSIONINFO) As Integer
Public Declare Function CopyFile Lib "kernel32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Public Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Public Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As Any) As Long


Public Sub Main()
Dim osinfo As OSVERSIONINFO
Dim rnt As Boolean
Dim Jaka_DLL As HKEYTypDll
Dim sCesta_ke_slozce_windows As String

If App.PrevInstance Then
MsgBox "Aplikace u jednou b!", vbExclamation
End
End If

osinfo.dwOSVersionInfoSize = Len(osinfo)
osinfo.szCSDVersion = Space$(128)
retvalue = GetVersionExA(osinfo)
'Zjisti platnost systemu, program pracuje nen na Win2000 a WnXP!!!
If osinfo.dwMajorVersion = WIN_2000_XP_NET Then 'Jedna se o Win2000, WinXP a Win .NET Server

    Let sCesta_ke_slozce_windows = Cesta_ke_slozce_windows()
    Let sCesta_ke_slozce_windows = sCesta_ke_slozce_windows + "\system32\"
    
    InitCommonControls_vb
    
    GoTo xxx
    
    
    Let rnt = Find_file(Odkud_se_spousim.Jen_cesta + "knihovna.dll")
    If rnt = True Then
        Let rnt = Set_Path_file("knihovna.dll", Jaka_DLL = API)
        If rnt = False Then
            End
        End If
    End If
    
    Let rnt = Find_file(Odkud_se_spousim.Jen_cesta + "AdresaPortu.dll")
    If rnt = False Then
        Let rnt = CopyFile(sCesta_ke_slozce_windows + "AdresaPortu.dll", Odkud_se_spousim.Jen_cesta + "AdresaPortu.dll", 0)
        If rnt = False Then
            MessageBox 0, "Not found AdresaPortu.dll", App.Title, MB_ICONSTOP
            End
        End If
    End If
    
    Let rnt = Find_file(Odkud_se_spousim.Jen_cesta + "Giveio.sys")
    If rnt = False Then
        Rem sem se skopiruje ovladac Giveio.sys
        Let sCesta_ke_slozce_windows = sCesta_ke_slozce_windows + "drivers\"
        Let rnt = CopyFile(sCesta_ke_slozce_windows + "Giveio.sys", Odkud_se_spousim.Jen_cesta + "Giveio.sys", 0)
        If rnt = False Then
            MessageBox 0, "Not found Giveio.sys", App.Title, MB_ICONSTOP
            End
        End If
    End If
    
xxx:
    ParallerPort.Show
Else
    MsgBox "Lituji, ale program je uren jen pro systm  Win2000 a vy!", vbOKOnly Or vbCritical, "Nesprvn Systm"
End If

End Sub

Private Function Set_Path_file(file As String, type_dll As HKEYTypDll) As Boolean
Dim klic As Long
Dim rnt As Boolean

'Najte potrebny strom a potom zacne hledat pozadovanou knihovnu, pokud ji v seznamu nenajde tak ji tam prida
'A typ knihovny se ridi potle nasledujici struknuty:
'Private Enum typ_dll
'    OTHER = 1
'    API = 2
'    ACTIVE_X = 3
'    OCX = 4
'End Enum

    
Call RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion\SharedDLLs", klic)
If klic = 0 Then
    Call RegCreateKey(HKEY_LOCAL_MACHINE, "SOFTWARE\Microsoft\Windows\CurrentVersion\SharedDLLs", klic)
End If
If klic <> 0 Then
    Let rnt = hledat_v_seznamu_knihovnu(file, klic)
    If rnt = False Then
        RegSetValueEx klic, "C:\WINDOWS\system32\" + file, 0, REG_DWORD, type_dll, 2 ' zapise cestu na knihovnu
    Else
        MsgBox "Lituji, ale nelze pracovat se systmovma registrama!", vbOKOnly Or vbCritical, "Chyba registr"
        Set_Path_file = False
    End If
End If
RegCloseKey klic
Set_Path_file = True
End Function

Private Function hledat_v_seznamu_knihovnu(file As String, klic As Long) As Boolean
'Samotne prohledavani seznamu
Dim sValue As String
Dim retDT As HKEYDataType
Dim lSize As Long
Dim rDT As HKEYDataType
Dim lDWord As Long


Rem ret = RegOpenKeyEx(hKey, sKey, 0&, KEY_QUERY_VALUE, hKey2)
    
    'Si todo va bien (se ha podido abrir la clave)
  
        'Leer esa entrada y obtener el tipo de dato, longitud, etc.
        ret = RegQueryValueEx(klic, sValue, 0&, retDT, 0&, lSize)
       Rem If retDT = REG_BINARY Then
            Rem If lSize Then
                Rem ReDim aData(lSize)
                Rem ret = RegQueryValueEx(klic, sValue, 0&, rDT, aData(0), lSize)
            Rem End If
        If retDT = REG_DWORD Then
            ret = RegQueryValueEx(klic, sValue, 0&, rDT, lDWord, lSize)
        Rem ElseIf retDT = REG_SZ Then
            Rem If lSize Then
                Rem sData = String$(lSize - 1, Chr$(0))
                Rem ret = RegQueryValueEx(hKey2, sValue, 0&, rDT, ByVal sData, lSize)
            Rem End If
        End If

 


Call RegQueryValueEx(klic, "x", 0, 0, Souradnice_X, 4)

End Function


